/* flip_da.c */

#include <Pilot.h>
#include "FlipHack.h"

#ifdef FLIP_DA
#include "flip_da_rcp.h"
#endif


/*
 * functions
 */

void DAMain(void)
{
    Err err = -1;
    FlipAngleT angle = kFlipNoAngle;

#ifdef FLIP_DA
    FormPtr form;
    Word button;
#endif

    CheckForCompatibility(true, &err);
    if (err == 0) {
	GetAngle(&angle);

#ifdef FLIP_DA

	form = FrmInitForm(MAIN_FORM_ID);
	if (angle >= kFlip0Deg && angle < kFlipNumAngles) {
	    FrmSetControlGroupSelection(
		    form, MAIN_FLIP_GROUP, MAIN_FLIP0_ID + angle);
	}
	button = FrmDoDialog(form);
	angle = FrmGetControlGroupSelection(form, MAIN_FLIP_GROUP)
		- FrmGetObjectIndex(form, MAIN_FLIP0_ID);
	FrmDeleteForm(form);
	if (button != MAIN_OK_ID
	 || (angle < kFlip0Deg || angle >= kFlipNumAngles)) {
	    return;
	}

#else

	if (angle == kFlipNoAngle) {
	    angle = kFlip0Deg;
	}

#ifdef FLIP_FLOP
	angle += kFlip180Deg;
#endif

#ifdef FLIP_RIGHT
	angle += kFlip90Deg;
#endif

#ifdef FLIP_LEFT
	angle -= kFlip90Deg;
#endif

	angle &= kFlip270Deg;

#endif /* FLIP_DA */

	SetAngle(&angle, NULL);
    }
}
